codeforces 1077D(二分)
程序员文章站
2024-03-11 22:02:31
...
题意描述
思路
由于移除的元素没有顺序要求,所以我们只需要考虑每个数字出现的次数。能够切割的最大次数是具有单调性的,所以我们可以二分出能够切割的最大长度,每个数字对长度的贡献为 c n t [ a [ i ] ] / l e n cnt[a[i]]/len cnt[a[i]]/len。最后再遍历一遍数组,输出满足条件的数字即可。还有一个注意的点是 c h e c k check check时,如果 > = k >=k >=k为true,因为大于等于写成等于导致错了5次。
AC代码
#include<bits/stdc++.h>
#define x first
#define y second
#define PB push_back
#define mst(x,a) memset(x,a,sizeof(x))
#define all(a) begin(a),end(a)
#define rep(x,l,u) for(ll x=l;x<u;x++)
#define rrep(x,l,u) for(ll x=l;x>=u;x--)
#define sz(x) x.size()
#define IOS ios::sync_with_stdio(false);cin.tie(0);
using namespace std;
typedef unsigned long long ull;
typedef pair<int,int> PII;
typedef pair<long,long> PLL;
typedef pair<char,char> PCC;
typedef long long ll;
const int N=2*1e5+10;
const int M=1e6+10;
const int INF=0x3f3f3f3f;
const int MOD=1e9+7;
/*注意边界
清空每个case的影响
注意数据范围
注意证明*/
int a[N],n,k;
map<int,int> cnt;
bool check(int mid){
int tot=0;
for(auto p : cnt){
int u=p.x,v=p.y;
if(v>=mid){
tot+=v/mid;
}
if(tot>=k) return true;
}
return false;
}
void solve(){
cin>>n>>k;
rep(i,0,n) cin>>a[i],cnt[a[i]]++;
int l=1,r=n;
while(l<r){
int mid=l+r+1>>1;
if(check(mid)) l=mid;
else r=mid-1;
}
vector<int> ans;
for(auto p : cnt){
int u=p.x,v=p.y;
if(v>=l){
int c=v/l;
rep(i,0,c) if(sz(ans)!=k) ans.PB(u);
if(sz(ans)==k) break;
}
}
rep(i,0,sz(ans)) cout<<ans[i]<<' ';
}
int main(){
IOS;
//int t;cin>>t;
//while(t--)
solve();
return 0;
}
推荐阅读
-
codeforces 1077D(二分)
-
Java使用二分法进行查找和排序的示例
-
Java使用二分法进行查找和排序的示例
-
【二分查找】旋转数组的最小数字
-
二分查找法查找旋转数组的最小值(Python)
-
Java基础知识回顾第一篇 - 数组和List之间的相互转换 | 二分法查找 | 冒泡排序 博客分类: Java基础知识回顾 冒泡排序二分法查找Java基础
-
【扫描线+计数去重】Codeforces Round #672 (Div. 2) D. Rescue Nibel!
-
快速求解方程的根——二分法与牛顿迭代法
-
Educational Codeforces Round 60 (Rated for Div. 2) D. Magic Gems 矩阵优化
-
【Educational Codeforces Round 53 (Rated for Div. 2)】